- Cal3D 0.11 API Reference -

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
cal3d::TiXmlNode Class Referenceabstract

The parent class for everything in the Document Object Model. More...

`#include <tinyxml.h>`

Inheritance diagram for cal3d::TiXmlNode:

## Public Types

enum | NodeType { DOCUMENT , ELEMENT , COMMENT , UNKNOWN , TEXT , DECLARATION , TYPECOUNT }
| The types of XML nodes supported by TinyXml. More...

## Public Member Functions

const char * | Value () const
| The meaning of 'value' changes for the specific type of TiXmlNode.
void | SetValue (const char *_value)
| Changes the value of the node.
void | SetValue (const std::string &_value)
| STL std::string form.
void | Clear ()
| Delete all the children of this node. Does not affect 'this'.
TiXmlNode * | Parent () const
| One step up the DOM.
TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'. Will be null if none found.
TiXmlNode * | LastChild () const
TiXmlNode * | LastChild (const char *value) const
| The last child of this node. Will be null if there are no children.
TiXmlNode * | FirstChild (const std::string &_value) const
| The last child of this node matching 'value'. Will be null if there are no children.
TiXmlNode * | LastChild (const std::string &_value) const
| STL std::string form.
TiXmlNode * | IterateChildren (TiXmlNode *previous) const
| An alternate way to walk the children of a node.
TiXmlNode * | IterateChildren (const char *value, TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'.
TiXmlNode * | IterateChildren (const std::string &_value, TiXmlNode *previous) const
| STL std::string form.
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
| Add a new node related to this.
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
| Replace a child of this node.
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node.
TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node.
TiXmlNode * | PreviousSibling (const std::string &_value) const
| STL std::string form.
TiXmlNode * | NextSibling (const std::string &_value) const
| STL std::string form.
TiXmlNode * | NextSibling () const
| Navigate to a sibling node.
TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'.
TiXmlElement * | NextSiblingElement () const
| Convenience function to get through elements.
TiXmlElement * | NextSiblingElement (const char *) const
| Convenience function to get through elements.
TiXmlElement * | NextSiblingElement (const std::string &_value) const
| STL std::string form.
TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const char *value) const
| Convenience function to get through elements.
TiXmlElement * | FirstChildElement (const std::string &_value) const
| STL std::string form.
virtual int | Type () const
| Query the type (as an enumerated value, above) of this node.
TiXmlDocument * | GetDocument () const
| Return a pointer to the Document this node lives in.
bool | NoChildren () const
| Returns true if this node has no children.
TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlText * | ToText () const
| Cast to a more defined type. Will return null not of the requested type.
TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null not of the requested type.
virtual TiXmlNode * | Clone () const =0
void | SetUserData (void *user)
void * | GetUserData ()
Public Member Functions inherited from cal3d::TiXmlBase
virtual void | Print (FILE *cfile, int depth) const =0
| All TinyXml classes can print themselves to a filestream.
int | Row () const
| Return the position, in the original source file, of this node or attribute.
int | Column () const
| See Row().

## Protected Member Functions

| TiXmlNode (NodeType type)
virtual void | StreamIn (TIXML_ISTREAM *in, TIXML_STRING *tag)=0
TiXmlNode * | Identify (const char *start)
void | CopyToClone (TiXmlNode *target) const
TIXML_STRING | SValue () const
Protected Member Functions inherited from cal3d::TiXmlBase
virtual void | StreamOut (TIXML_OSTREAM *) const =0
virtual const char * | Parse (const char *p, TiXmlParsingData *data)=0

## Protected Attributes

TiXmlNode * | parent
NodeType | type
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TIXML_STRING | value
TiXmlNode * | prev
TiXmlNode * | next
void * | userData
Protected Attributes inherited from cal3d::TiXmlBase
TiXmlCursor | location

## Friends

class | TiXmlDocument
class | TiXmlElement
std::istream & | operator>> (std::istream &in, TiXmlNode &base)
| An input stream operator, for every class.
std::ostream & | operator<< (std::ostream &out, const TiXmlNode &base)
| An output stream operator, for every class.
std::string & | operator<< (std::string &out, const TiXmlNode &base)
| Appends the XML node or attribute to a std::string.

## Additional Inherited Members

Static Public Member Functions inherited from cal3d::TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
| The world does not agree on whether white space should be kept or not.
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting.
Protected Types inherited from cal3d::TiXmlBase

enum

{
TIXML_NO_ERROR = 0 , TIXML_ERROR , TIXML_ERROR_OPENING_FILE , TIXML_ERROR_OUT_OF_MEMORY ,
TIXML_ERROR_PARSING_ELEMENT , TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME , TIXML_ERROR_READING_ELEMENT_VALUE , TIXML_ERROR_READING_ATTRIBUTES ,
TIXML_ERROR_PARSING_EMPTY , TIXML_ERROR_READING_END_TAG , TIXML_ERROR_PARSING_UNKNOWN , TIXML_ERROR_PARSING_COMMENT ,
TIXML_ERROR_PARSING_DECLARATION , TIXML_ERROR_DOCUMENT_EMPTY , TIXML_ERROR_STRING_COUNT
}

Static Protected Member Functions inherited from cal3d::TiXmlBase
static const char * | SkipWhiteSpace (const char *)
static bool | IsWhiteSpace (int c)
static bool | StreamWhiteSpace (TIXML_ISTREAM *in, TIXML_STRING *tag)
static bool | StreamTo (TIXML_ISTREAM *in, int character, TIXML_STRING *tag)
static const char * | ReadName (const char *p, TIXML_STRING *name)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase)
static const char * | GetEntity (const char *in, char *value)
static const char * | GetChar (const char *p, char *_value)
static void | PutString (const TIXML_STRING &str, TIXML_OSTREAM *out)
static void | PutString (const TIXML_STRING &str, TIXML_STRING *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase)
Static Protected Attributes inherited from cal3d::TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

The parent class for everything in the Document Object Model.

(Except for attributes). Nodes have siblings, a parent, and children. A node can be in a document, or stand on its own. The type of a TiXmlNode can be queried, and it can be cast to its more defined type.

## Member Enumeration Documentation

## ◆ NodeType

enum cal3d::TiXmlNode::NodeType

The types of XML nodes supported by TinyXml.

(All the unsupported types are picked up by UNKNOWN.)

## Member Function Documentation

## ◆ FirstChild()

TiXmlNode * cal3d::TiXmlNode::FirstChild | ( | const std::string & | _value | ) | const

inline

The last child of this node matching 'value'. Will be null if there are no children.

STL std::string form.

## ◆ GetDocument()

TiXmlDocument * cal3d::TiXmlNode::GetDocument | ( |  | ) | const

Return a pointer to the Document this node lives in.

Returns null if not in a document.

## ◆ InsertAfterChild()

TiXmlNode * cal3d::TiXmlNode::InsertAfterChild | ( | TiXmlNode * | afterThis,
|  | const TiXmlNode & | addThis )

Add a new node related to this.

Adds a child after the specified child. Returns a pointer to the new object or NULL if an error occured.

## ◆ InsertBeforeChild()

TiXmlNode * cal3d::TiXmlNode::InsertBeforeChild | ( | TiXmlNode * | beforeThis,
|  | const TiXmlNode & | addThis )

Add a new node related to this.

Adds a child before the specified child. Returns a pointer to the new object or NULL if an error occured.

## ◆ InsertEndChild()

TiXmlNode * cal3d::TiXmlNode::InsertEndChild | ( | const TiXmlNode & | addThis | ) |

Add a new node related to this.

Adds a child past the LastChild. Returns a pointer to the new object or NULL if an error occured.

## ◆ IterateChildren()

TiXmlNode * cal3d::TiXmlNode::IterateChildren | ( | TiXmlNode * | previous | ) | const

An alternate way to walk the children of a node.

One way to iterate over nodes is:

        for( child = parent->FirstChild(); child; child = child->NextSibling() )

IterateChildren does the same thing with the syntax:

        child = 0;
        while( child = parent->IterateChildren( child ) )

IterateChildren takes the previous child as input and finds the next one. If the previous child is null, it returns the first. IterateChildren will return null when done.

## ◆ LinkEndChild()

TiXmlNode * cal3d::TiXmlNode::LinkEndChild | ( | TiXmlNode * | addThis | ) |

Add a new node related to this.

Adds a child past the LastChild.

NOTE: the node to be added is passed by pointer, and will be henceforth owned (and deleted) by tinyXml. This method is efficient and avoids an extra copy, but should be used with care as it uses a different memory model than the other insert functions.

See also
  InsertEndChild

## ◆ NextSiblingElement() [1/2]

TiXmlElement * cal3d::TiXmlNode::NextSiblingElement | ( |  | ) | const

Convenience function to get through elements.

Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

## ◆ NextSiblingElement() [2/2]

TiXmlElement * cal3d::TiXmlNode::NextSiblingElement | ( | const char * | _value | ) | const

Convenience function to get through elements.

Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

## ◆ ReplaceChild()

TiXmlNode * cal3d::TiXmlNode::ReplaceChild | ( | TiXmlNode * | replaceThis,
|  | const TiXmlNode & | withThis )

Replace a child of this node.

Returns a pointer to the new object or NULL if an error occured.

## ◆ SetValue()

void cal3d::TiXmlNode::SetValue | ( | const char * | _value | ) |

inline

Changes the value of the node.

Defined as:

    Document:   filename of the xml file
    Element:    name of the element
    Comment:    the comment text
    Unknown:    the tag contents
    Text:       the text string

## ◆ Type()

virtual int cal3d::TiXmlNode::Type | ( |  | ) | const

inline virtual

Query the type (as an enumerated value, above) of this node.

The possible types are: DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, and DECLARATION.

## ◆ Value()

const char * cal3d::TiXmlNode::Value | ( |  | ) | const

inline

The meaning of 'value' changes for the specific type of TiXmlNode.

    Document:   filename of the xml file
    Element:    name of the element
    Comment:    the comment text
    Unknown:    the tag contents
    Text:       the text string

The subclasses will wrap this function.

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | out,
|  | const TiXmlNode & | base )

friend

An output stream operator, for every class.

Note that this outputs without any newlines or formatting, as opposed to Print(), which includes tabs and new lines.

The operator<< and operator>> are not completely symmetric. Writing a node to a stream is very well defined. You'll get a nice stream of output, without any extra whitespace or newlines.

But reading is not as well defined. (As it always is.) If you create a TiXmlElement (for example) and read that from an input stream, the text needs to define an element or junk will result. This is true of all input streams, but it's worth keeping in mind.

A TiXmlDocument will read nodes until it reads a root element, and all the children of that root element.

## ◆ operator>>

std::istream & operator>> | ( | std::istream & | in,
|  | TiXmlNode & | base )

friend

An input stream operator, for every class.

Tolerant of newlines and formatting, but doesn't expect them.

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp
- tinyxmlparser.cpp

Generated by The Cal3D Team with Doxygen 1.15.0